#include <iostream>
#include <cstdio>

using namespace std;

int n, k;
long long rez;
int a[100005];
int nizmax[70000005];

//Pazi sad
//ideja je da nadjem najvece u nizu
//i da onda rekurzivno trazim pre i posle najvecih
//Mislim da se svodi na N^2, ali je optimizovano i to

void nadji(int l, int d, int th, int brtmp)
{
    if(l-d>0) return;
    if(l-d==0)
    {
        rez+=th-a[l];
        return;
    }
    int i;
    int br=brtmp;
    int max1=-5;
    for(i=l; i<=d; i++)
    {
        if(a[i]>max1)
        {
            br=brtmp+1;
            nizmax[brtmp]=i;
            max1=a[i];
        }
        else if(a[i]==max1)
        {
            nizmax[br]=i;
            br++;
        }
    }
    rez+=th-max1;
    i=brtmp+1;
    if(br==brtmp+1)
    {
        if(nizmax[brtmp]!=l && nizmax[brtmp]!=d)
        {
            nadji(l, nizmax[brtmp]-1, max1, br);
            nadji(nizmax[brtmp]+1, d, max1, br);
        }
        else if(nizmax[brtmp]==l)
            nadji(l+1, d, max1, br);
        else nadji(l, d-1, max1, br);
    }
    else
    {
        if(nizmax[brtmp]!=l && nizmax[br-1]!=d)
            nadji(l, nizmax[brtmp]-1, max1, br);
        else
        {
            nadji(l, nizmax[brtmp+1]-1, max1, br);
        }
        for(i; i<br; i++)
            nadji(nizmax[i]+1, nizmax[i+1]-1, max1, br);
        if(nizmax[br-1]!=d) nadji(nizmax[br-1], d, max1, br);
    }
}

int main()
{
    int i;
    freopen("zetoni.in", "r", stdin);
    freopen("zetoni.out", "w", stdout);
    scanf("%i %i", &n, &k);
    for(i=0; i<n; i++)
        scanf("%i", &a[i]);
    nadji(0, n-1, k, 0);
    printf("%lld\n", rez);
    return 0;
}
